********************************************************************************
* ACHOICE: Funcao para criar menus PopUp.
* --------
*
*   Parametros: l1,c1,l2,c2 -> Coordenadas do achoice
*               Array1      -> Lista do itens do menu
*               Array2      -> Lista do itens que podem ser selecionados. So podem ser .T. ou .F. cada elemento
*                              Obs: Deve ter a mesma qtd de elementos do Array1
*               USRFUNC     -> Funcao do usuario
*               ELE         -> N do Elemento atual
*               ROW         -> N da linha referente as coordenadas do achoice
*
*      Retorno: A funcao retorna o numero do elemento selecionado pelo ENTER ou 0 quando ESC
*
********************************************************************************
* Compilacao: Clipper FACHOICE
* Linkedicao: Rtlink fi FACHOICE
********************************************************************************
* Autor: Edmilson Jr de Lemos Malaquias Email: ejlm@zipmail.com.br
* Qualquer duvida, mande-me um e-mail.
********************************************************************************

//*** Sets
Set Scoreboard Off
Set Key 28 To Ajuda() //Atribuindo a tecla F1 a funcao Ajuda
SetColor("W/N,N/W")
Setmode(25,80) //Configurando o video para 25 linhas com 80 colunas

//*** Array com os itens do achoice
aItens := {}
For x := 1 To 30
    Aadd(aItens,"Item "+Strzero(x,2))
Next

//*** Array com os flags que indicam se o item selecionado com o ENTER pode ser executado ou nao.
aSelects := {}
For x := 1 To 30
    Aadd(aSelects,.T.)
Next

//*** Variaveis  de controle.
nNum := 1 //Numero do item corrente.
nRow := 0 //Numero da posicao do item referente a tela.

//*** Desenhando a Tela
Cls
@ 00,00 Say Padc("Exemplo da funcao Achoice",80) Color "N/W"
@ 24,00 Say Padr("[ESC] -> Abandona [F1] -> Ajuda",80) Color "N/W"
@ 01,01 To 23,21
@ 06,25 Say "Conteudo do Item atual: "+Padr(aItens[nNum],40)
@ 07,25 Say "N do Item atual......: "+Strzero(nNum,3)
If Len(aItens) > 21
   @ 22,01 Say "" Color "GR+/N"
Endif
//*** Lao principal
Do While .T. //Ficar nesse lao para sempre

   nNum := Achoice(02,02,22,20,aItens,aSelects,"ac_func",nNum,nRow)

   Do Case
      Case nNum == 0 //Foi precionado ESC
           If Alert("Abandona achoice ?",{"Sim","Nao"}) == 1
              Exit
           Endif
      Case Lastkey() == 13 //Enter
           aItens[nNum] += " Alterado"
      Case Lastkey() == 07 //Del
           If Alert("Exclui o item "+aItens[nNum]+" ?",{"Sim","Nao"}) == 1
              Adel(aItens,nNum)
              ASize(aItens,Len(aItens)-1)
              Adel(aSelects,nNum)
              ASize(aSelects,Len(aSelects)-1)
           Endif
      Case Lastkey() == 021 //Ctrl U
           nEle := 0
           @ 24,33 Say "Digite o n do elemento a ser restaurado: " Color "N/W"
           @ 24,Col() Get nEle Picture "999" Valid nEle > 0 .And. nEle <= Len(aSelects)
           Read
           @ 24,00 Say Padr("[ESC] -> Abandona [F1] -> Ajuda",80) Color "N/W"
           If Lastkey() <> 27
              aSelects[nEle] := .T.
              nNum := nEle
           Endif
      Case Lastkey() == 022 //Ins
           ASize(aItens,Len(aItens)+1)
           AIns(aItens,nNum)
           aItens[nNum] := "Item inserido"
           ASize(aSelects,Len(aSelects)+1)
           AIns(aSelects,nNum)
           aSelects[nNum] := .T.
      Case Lastkey() == 403 //Ctrl Del
           If Alert("Desabilita o item "+aItens[nNum]+" ?",{"Sim","Nao"}) == 1
              aSelects[nNum] := .F.
           Endif
      Case Lastkey() == 416 //Alt Down
           If nNum < Len(aItens)
              cAtu := aItens[nNum]
              aItens[nNum] := aItens[nNum+1]
              aItens[nNum+1] := cAtu
              KeyBoard Chr(24) //Forcando a tecla BAIXO
           Endif
      Case Lastkey() == 408 //Alt Up
           If nNum > 1
              cAtu := aItens[nNum]
              aItens[nNum] := aItens[nNum-1]
              aItens[nNum-1] := cAtu
              KeyBoard Chr(05) //Forcando a tecla CIMA
           Endif
   Endcase

Enddo

Set Color To
Cls
Return

******************************
Function ac_func(modo,ele,row)
nRow := row //Atualizando a posicao do item com relacao as coordenadas do achoice
Do Case
   Case modo == 0 //Tecla de movimentacao
        Tone(300,1)
        If ele-row > 1
           @ 02,01 Say "" Color "GR+/N"
         Else
           @ 02,01 Say ""
        Endif
        If ele-row-1+21 < Len(aItens)
           @ 22,01 Say "" Color "GR+/N"
         Else
           @ 22,01 Say ""
        Endif
        @ 06,25 Say "Conteudo do Item atual: "+Padr(aItens[ele],40)
        @ 07,25 Say "N do Item atual......: "+Strzero(ele,3)
   Case modo == 1 //Se for precionado seta para cima no 1 item
        Tone(300,1)
        Keyboard Chr(30) //Forca a Tecla Ctrl PgDn e o item atual sera o ultimo
   Case modo == 2 //Se for precionado seta para baixo no ultimo item
        Tone(300,1)
        Keyboard Chr(31) //Forca a Tecla Ctrl PgUp e o item atual sera o primeiro
   Case modo == 3 //Teclas de excessao
        Do Case
           Case Lastkey() == 027 //Esc
                Return (0)
           Case Lastkey() == 013 //Enter
                Return (1)
           Case Lastkey() == 007 //Del
                Return (1)
           Case Lastkey() == 022 //Ins
                Return (1)
           Case Lastkey() == 403 //Ctrl Del
                Return (1)
           Case Lastkey() == 416 //Alt Down
                Return (1)
           Case Lastkey() == 408 //Alt Up
                Return (1)
           Case Lastkey() == 021 //Ctrl U
                Return (1)
           Case Upper(Chr(Lastkey())) $ "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                Return (3)
        Endcase
Endcase
Return (2)

********************************************************************************
Function Ajuda()
********************************************************************************
Local aAjuda,cTelaAnt := Savescreen(),cCorAnt:=SetColor("N/W")
aAjuda := {}
Aadd(aAjuda,"[AJUDA]Ŀ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," ESC      -> Sai do programa                   ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," ENTER    -> Aciona o item corrente            ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," INS      -> Insere um item                    ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," DEL      -> Exclui o Item corrente            ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," CTRL DEL -> Desabilita o item corrente        ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," CTRL U   -> Abilita o item informado          ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," ALT UP   -> Troca o item atual com o de cima  ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda," ALT DOWN -> Troca o item atual com o de baixo ")
Aadd(aAjuda,"                                               ")
Aadd(aAjuda,"[Precione qualquer tecla]")
Center(aAjuda)
Inkey(0)
Restscreen(,,,,cTelaAnt)
SetColor(cCorAnt)
Return

********************************************************************************
Function Center(ARRAY) //Centraliza um array na tela
********************************************************************************
Local l,c,x
l := (MaxRow()+1-Len(ARRAY))/2
c := (Maxcol()+1-Len(ARRAY[1]))/2
For x := 1 To Len(ARRAY)
    @ l++,c Say ARRAY[x]
Next

